Scripts: Difference between revisions

From FreeCAD Documentation
No edit summary
No edit summary
 
(81 intermediate revisions by 9 users not shown)
Line 1: Line 1:
<languages/>
<translate>


<!--T:42-->
== Editing Scripts ==
{{Docnav
|[[Macros|Macros]]
|[[Introduction_to_Python|Introduction to Python]]
}}


<!--T:1-->
'''Work in progress sorry for the inconvenience'''
{{TutorialInfo
|Topic=Scripting
|Level=Base
|Time=
|Author=onekk Carlo
|FCVersion=0.19
|Files=
}}


== Introduction == <!--T:2-->
With Scripting we mean create topological objects using FreeCAD Python interpreter. FreeCAD could be used a "very good" replacement of OpenSCAD, manìinly beacause it has a real Python interpreter, that means that it has a real programming language on board, almost everything you could do with the GUI, is doable with a Python Script.


<!--T:3-->
With Scripting we mean create topological objects using FreeCAD's Python interpreter. FreeCAD could be used as a "very good" replacement of OpenSCAD, mainly because it has a real Python interpreter, that means that it has a real programming language on board, almost everything you could do with the GUI, is doable with a Python Script.

<!--T:4-->
Sadly information about scripting in the documentation, and even in this wiki are scattered around and lacks of "writing" uniformity and most of them are explained in a too technical manner.
Sadly information about scripting in the documentation, and even in this wiki are scattered around and lacks of "writing" uniformity and most of them are explained in a too technical manner.


== Getting started == <!--T:5-->


<!--T:6-->
== Wetting you appetite ==
The first obstacle in an easy way to scripting is that there is no direct way to access the FreeCAD internal Python editor through a menu item or a icon on the toolbar area, but knowing that FreeCAD opens a file with a {{incode|.py}} extension in the internal Python editor, the most simple trick is create in your favourite text editor and then open it with the usual command '''File - Open'''.
The first obstacle in an easy way to scripting is that there is no direct way to access the FreeCAD internal Python editor through a menu item or a icon on the toolbar area, but knowing that FreeCAD opens a file with a {{incode|.py}} extension in the internal Python editor, the most simple trick is create in your favorite text editor and then open it with the usual command {{MenuCommand|File Open}}.


<!--T:7-->
To make the things in a polite way, the fila has to be written with some order, FreeCAD Python editor have a good "Syntax HIghlighting" that lacks in many simple editors like Windows Notepad or some basic Linux editors, so it is sufficient to write these few lines:
To make the things in a polite way, the file has to be written with some order, FreeCAD Python editor have a good "Syntax Highlighting" that lacks in many simple editors like Windows Notepad or some basic Linux editors, so it is sufficient to write these few lines:


</translate>
{{Code|code=
{{Code|code=
"""script.py
"""filename.py


A short description of what the script does
Primo script per FreeCAD


"""
"""

}}
}}
<translate>


<!--T:8-->
Save them with a meaningfull name with {{incode|.py}} extension and load the resulting file in FreeCAD, with the said '''File - Open''' command.
Save them with a meaningfull name with {{incode|.py}} extension and load the resulting file in FreeCAD, with the said {{MenuCommand|File → Open}} command.



<!--T:9-->
A minimal example of what is necessary to have in a script is shown in this portion of code that you could be use as a template for almost any future script:
A minimal example of what is necessary to have in a script is shown in this portion of code that you could be use as a template for almost any future script:


</translate>
{{Code|code=
{{Code|code=
"""filename.py
"""filename.py


First FreeCAD Script
Here a short but significant description of what the script do


"""
"""


import FreeCAD
import FreeCAD
from FreeCAD import Base, Vector
from FreeCAD import Placement, Rotation, Vector
import Part
from math import pi, sin, cos


DOC = FreeCAD.activeDocument()
DOC = FreeCAD.activeDocument()
DOC_NAME = "Pippo"
DOC_NAME = "Wiki_Example"

# Helpers methods


def clear_doc():
def clear_doc():
"""Clear activeDocument deleting all the objects."""
"""
Clear the active document deleting all the objects
"""
for obj in DOC.Objects:
for obj in DOC.Objects:
DOC.removeObject(obj.Name)
DOC.removeObject(obj.Name)


def setview():
def setview():
"""Rearrange View"""
"""Rearrange View."""
FreeCAD.Gui.SendMsgToActiveView("ViewFit")
FreeCAD.Gui.SendMsgToActiveView("ViewFit")
FreeCAD.Gui.activeDocument().activeView().viewAxometric()
FreeCAD.Gui.activeDocument().activeView().viewAxometric()



if DOC is None:
if DOC is None:
Line 60: Line 80:
FreeCAD.setActiveDocument(DOC_NAME)
FreeCAD.setActiveDocument(DOC_NAME)
DOC = FreeCAD.activeDocument()
DOC = FreeCAD.activeDocument()

else:
else:

clear_doc()
clear_doc()


ROT0 = Rotation(0, 0, 0)
# EPS= tolerance to use to cut the parts
VEC0 = Vector(0, 0, 0)
EPS = 0.10
EPS_C = EPS * -0.5

}}
}}
<translate>


<!--T:10-->
Some tricks are incorporated in the above code:
Some tricks are incorporated in the above code:


<!--T:11-->
* {{incode|import FreeCAD}} This line import FreeCAD in the FreeCAD Python interpreter, it may seem a redundant thing, but it isn't.
* {{incode|from FreeCAD import Placement, Rotation, Vector}} '''Placement''' '''Rotation''' and '''Vector''' are widely used in FreeCAD scripting, import them in this manner will save you to invoke them with {{incode|FreeCAD.Vector}} or {{incode|FreeCAD.Placement}} instead of {{incode|Vector}} or {{incode|Placement}}, this will save many keystrokes and make codelines much smaller.


<!--T:12-->
* {{incode|import FreeCAD}} This line import FreeCAD in the FreeCAD Python interpreter, it may seem a redundant thing, but it isn't
* {{incode|from FreeCAD import Base, Vector}} Base and Vector are widely used in FreeCAD scipting, import them in this manner will save you to invoke them with {{incode|FreeCAD.Vector}} or {{incode|FreeCAD.Base}} instead of {{incode|Base}} or {{incode|Vector}}, this will save many keystrokes and make codelines much smaller.


Let's start with a small script that does a very small job, but display the power of this approach.
Let's start with a small script that does a very small job, but display the power of this approach.


</translate>
{{Code|code=
# Script methods


def my_box(name, len, wid, hei):
{{Code|code=
"""Create a box."""
def cubo(nome, lung, larg, alt):
obj_b = DOC.addObject("Part::Box", nome)
obj_b = DOC.addObject("Part::Box", name)
obj_b.Length = lung
obj_b.Length = len
obj_b.Width = larg
obj_b.Width = wid
obj_b.Height = alt
obj_b.Height = hei


DOC.recompute()
DOC.recompute()
Line 92: Line 113:
return obj_b
return obj_b


# objects definition
obj = cubo("test_cube", 5, 5, 5)


obj = my_box("test_cube", 5, 5, 5)
setview()


setview()
}}
}}
<translate>


<!--T:13-->
Write above lines of code after {{incode|# Script methods}} and press the green arrow in the '''Macro toolbar'''


<!--T:14-->
Put these lines after the "template" code and press the green arrow in the '''Macro toolbar'''
You will see some magic things, a new document is open named "Wiki_example" and you will see in the 3d view a [[Part_Box|Cube]], like the one in the image below.


<!--T:44-->
You will see some magic things, a new document is open named "Pippo" (Italian name of '''Goofy''') and you will see in the 3d view a cube, like the one in the image below.
[[File:Cubo.png|thumb|center|Test cube]]


== Something more == <!--T:15-->
[[File:Cubo.png|thumb|center|Cubo di prova]]


<!--T:16-->
== Something more... ==
Not that amazing? Yes, but we have to start somewhere, we can do the same thing with a [[Part_Cylinder|Cylinder]], add these lines of code after the {{incode|my_box()}} method and before the line: {{incode|# objects definition}}.

Not too amazing? Yes, but we have to start somewhere, same thing we can do with a Cylinder, add these lines of code after the {{incode|cubo(}} method and before the line {{incode|obj = cubo(...'}}.


</translate>
{{Code|code=
{{Code|code=
def base_cyl(nome, ang, rad, alt ):
def my_cyl(name, ang, rad, hei):
"""Create a Cylinder."""
obj = DOC.addObject("Part::Cylinder", nome)
obj = DOC.addObject("Part::Cylinder", name)
obj.Angle = ang
obj.Angle = ang
obj.Radius = rad
obj.Radius = rad
obj.Height = alt
obj.Height = hei

DOC.recompute()
DOC.recompute()


return obj
return obj

}}
}}
<translate>


<!--T:17-->
Even here nothing too exciting. But please note some peculiarities:


<!--T:18-->
Even here nothig too exciting. But please note some peculiarities:
* The absence of the usual reference to the {{incode|App.}}, present in many Documentation code snippets, is deliberate, this code could be used even invoking FreeCAD as a module in an external Python interpreter, the thing is not easily doable with an AppImage, but with some care it could be done. Plus in the standard Python motto that "better explicit than implicit" {{incode|App.}} is explaining in a very "poor" way where the things are from.
* Note the use of the "constant" name assigned to the active Document in {{incode|DOC &#61; FreeCAD.activeDocument()}}; activeDocument is not a "constant" in a strict sense, but in a "semantical" way is our "active Document", that for our use is a proper "constant" so the Python convention to use the "ALL CAPS" name for "constants", not to mention that {{incode|DOC}} is much shorten than {{incode|FreeCAD.activeDocument()}}.
* Every method returns a geometry, this will be clear in the continuation of the page.
* Geometry didn't have the {{incode|Placement}} property, when using the simple geometries to make more complex geometry, managing {{incode|Placement}} is a awkward thing.


<!--T:19-->
* The absence of the usual reference to the {{incode|App.}}, present in many Documentation code snippets, is deliberate, this code could be used even invoking FreeCAD as a module in an external Python, the thing is not easily doable with an AppImage, but with some care it could be done. Plus in the standard Python motto that "better explicit than implicit" {{incode|App.}} is explaining in a very "poor" way where the things are from.
Now what to do with this geometries?
* {{incode|DOC = FreeCAD.activeDocument()}}, note the use of the "constant" name assigned to the active Document, that is not a "constant" in a strict mean, but in a "semantical" way is our "active Document", that four our use is a proper "constant" so the Python convention to use the "ALL CAPS" name for "constants", not to mention that {{incode|DOC}} is much shorten than {{incode|FreeCAD.activeDocument()}}.
* every method returns a geometry, this became clear in the continuation of the page.
* geometry didn't have the {{incode|Placement}} property, when usign the simple geometries to make more complex geometry, managing {{incode|Placement}} is a ankward thing.


<!--T:20-->
Ora dobbiamo pur farci qualcosa con questi oggetti, quindi introduciamo le operazioni booleane. Un esempio di metodo che compie un'operazione di '''Unione''' è questo:
Let's introduce boolean operations. As a starter example put these lines after {{incode|my_cyl}}, this create a method for a '''Fusion''' also know as '''Union''' operation:


</translate>
{{Code|code=
{{Code|code=
def fuse_obj(nome, obj_0, obj_1):
def fuse_obj(name, obj_0, obj_1):
"""Fuse two objects."""
obj = DOC.addObject("Part::Fuse", nome)
obj = DOC.addObject("Part::Fuse", name)
obj.Base = obj_0
obj.Base = obj_0
obj.Tool = obj_1
obj.Tool = obj_1
Line 142: Line 177:
return obj
return obj
}}
}}
<translate>


<!--T:21-->
Nothing exceptional also here, note however the uniformity in method coding; This approach is more linear that those seen around other tutorial on scripting, this "linearity" help greatly in readability and also with cut-copy-paste operations.


<!--T:22-->
anche qui nulla di eccezionale, notate però l'uso di molta uniformità nel codice, aiuta molto quando si vuole fare copia e incolla nella creazioni complesse.
Let's use the geometries, delete lines below the code section starting with {{incode|# objects definition}}, and insert the following lines:

Inseriamo dopo il metodo {{incode|base_cyl}} le righe sopra e modifichiamo quelle sotto in modo da leggere:


</translate>
{{Code|code=
{{Code|code=
# objects definition


obj = my_box("test_cube", 5, 5, 5)
# definizione oggetti


obj = cubo("cubo_di_prova", 5, 5, 5)
obj1 = my_cyl("test_cyl", 360, 2, 10)


fuse_obj("Fusion", obj, obj1)
obj1 = base_cyl('primo cilindro', 360,2,10)


setview()
fuse_obj("Fusione", obj, obj1)
}}
}}
<translate>


<!--T:23-->
Lanciamo con il tasto freccia della '''barra strumenti macro''' e otteniamo:
Launch the script with the green arrow and we will see in the 3D view something like:


<!--T:45-->
[[File:Cucil.png|thumb|center|cubo e cilindro]]
[[File:Cucil.png|thumb|center|Cube and cylinder]]


== Placement == <!--T:24-->


<!--T:25-->
== Posizionamento ==
Placement Concept is relatively complex, see [[Aeroplane|Aeroplane Tutorial]] for a more deep explanation.


<!--T:26-->
Il concetto è relativamente complesso, vedere il [[Aeroplane/it|Tutorial aeroplano]] per una trattazione più sistematica.
We usually are in need of placing geometries respect each other, when building complex object this is a recurring task, the most common way is to use the geometry {{incode|Placement}} property.


<!--T:27-->
Possiamo aver bisogno di posizionare una geometria in una posizione relativa ad un'altra geometria, cosa abbastanza frequente, il modo più comune è usare la proprietà {{incode|Placement}} della geometria.
FreeCAD offer a wide choice of ways to set this property, one is more tailored to another depending the knowledge and the background of the user, but the more plain writing is explained in the cited Tutorial, it use a peculiar definition of the {{incode|Rotation}} portion of {{incode|Placement}}, quite easy to learn.


</translate>
Ovviamente le possibilità su come specificare questa proprietà sono molte, alcune complesse da capire, questa scrittura della proprietà {{incode|Placement}}, soprattutto per quanto riguarda la parte {{incode|Rotation}} è in linea con quanto spiegato nel Tutorial citato e sembra la più gestibile.
{{Code|code=

FreeCAD.Placement(Vector(0, 0, 0), FreeCAD.Rotation(10, 20, 30), Vector(0, 0, 0))
{{Code|code=
FreeCAD.Placement(Vector(0,0,0), FreeCAD.Rotation(10,20,30), Vector(0,0,0))
}}
}}
<translate>


<!--T:28-->
But over other consideration, one thing is crucial, geometry '''reference point''', in other words the point from which the object is modeled by FreeCAD, as described in this table, copied from [[Placement|Placement]]:


<!--T:29-->
Esiste sempre un punto di criticità, che è il punto di '''riferimento della costruzione''', cioè il punto in base al quale è costruito l'oggetto, come descritto in questa tabella, copiata da [[Placement/it|Posizionamento]]:


{| class="wikitable" border="1"
{| class="wikitable" border="1"
!Object!!Reference Point
!Geometria!!Riferimento di Costruzione
|-
|- align="left"
|Part::Box ||vertice sinistro (minimo x), frontale (minimo y), in basso (minimo z)
|Part.Box ||left (minx), front (miny), bottom (minz) vertex
|-
|- align="left"
|Part::Sphere||centro della sfera (centro del suo contenitore cubico)
|Part.Sphere||center of the sphere
|-
|- align="left"
|Part::Cylinder||centro della faccia di base
|Part.Cylinder||center of the bottom face
|-
|- align="left"
|Part::Cone||centro della faccia di base (o superiore se il raggio della faccia di base vale 0)
|Part.Cone||center of bottom face (or apex if bottom radius is 0)
|-
|- align="left"
|Part::Torus||centro del toro
|Part.Torus||center of the torus
|-
|- align="left"
|Features derived from Sketches||the Feature inherits the Position of the underlying Sketch. Sketches always start with Position = (0, 0, 0). This position corresponds to the origin in the sketch.
|Caratteristiche derivate da Sketch||la caratteristica eredita la posizione dello schizzo sottostante. Lo schizzo inizia sempre con Position = (0,0,0).
|}
|}


<!--T:30-->
This information has to be kept in mind especially when we have to apply a rotation.


<!--T:31-->
Queste informazioni sono da tenere ben presente quando volete applicare una rotazione.
Some examples may help, delete all the line after {{incode|my_cyl}} method and insert the portion of code below:

Facciamo qualche esempio, cancellate tutte le righe dopo il metodo {{incode|base_cyl}} ed inserite queste righe:


</translate>
{{Code|code=
{{Code|code=
def my_sphere(name, rad):

"""Create a Sphere."""
def sfera(nome, rad):
obj = DOC.addObject("Part::Sphere", nome)
obj = DOC.addObject("Part::Sphere", name)
obj.Radius = rad
obj.Radius = rad

DOC.recompute()
DOC.recompute()


return obj
return obj


def my_box2(name, len, wid, hei, cent=False, off_z=0):
"""Create a box with an optional z offset."""
obj_b = DOC.addObject("Part::Box", name)
obj_b.Length = len
obj_b.Width = wid
obj_b.Height = hei


if cent is True:
def mfuse_obj(nome, objs):
pos = Vector(len * -0.5, wid * -0.5, off_z)
obj = DOC.addObject("Part::MultiFuse", nome)
else:
pos = Vector(0, 0, off_z)

obj_b.Placement = Placement(pos, ROT0, VEC0)

DOC.recompute()

return obj_b

def mfuse_obj(name, objs):
"""Fuse multiple objects."""
obj = DOC.addObject("Part::MultiFuse", name)
obj.Shapes = objs
obj.Shapes = objs
obj.Refine = True
obj.Refine = True
Line 220: Line 286:
return obj
return obj


def airplane():
"""Create an airplane shaped solid."""
fuselage_length = 30
fuselage_diameter = 5
wing_span = fuselage_length * 1.75
wing_width = 7.5
wing_thickness = 1.5
tail_height = fuselage_diameter * 3.0
tail_position = fuselage_length * 0.70
tail_offset = tail_position - (wing_width * 0.5)


obj1 = my_cyl("main_body", 360, fuselage_diameter, fuselage_length)
def aeroplano():

lung_fus = 30
diam_fus = 5
ap_alare = lung_fus * 1.75
larg_ali = 7.5
spess_ali = 1.5
alt_imp = diam_fus * 3.0
pos_ali = (lung_fus*0.70)
off_ali = (pos_ali - (larg_ali * 0.5))

obj1 = base_cyl('primo cilindro', 360, diam_fus, lung_fus)


obj2 = cubo('ali', ap_alare, spess_ali, larg_ali, True, off_ali)
obj2 = my_box2("wings", wing_span, wing_thickness, wing_width, True, tail_offset)


obj3 = sfera("naso", diam_fus)
obj3 = my_sphere("nose", fuselage_diameter)
obj3.Placement = FreeCAD.Placement(Vector(0,0,lung_fus), FreeCAD.Rotation(0,0,0), Vector(0,0,0))
obj3.Placement = Placement(Vector(0, 0, fuselage_length), ROT0, VEC0)


obj4 = cubo('impennaggio', spess_ali, alt_imp, larg_ali, False, 0)
obj4 = my_box2("tail", wing_thickness, tail_height, wing_width, False, 0)
obj4.Placement = FreeCAD.Placement(Vector(0,alt_imp * -1,0), FreeCAD.Rotation(0,0,0), Vector(0,0,0))
obj4.Placement = Placement(Vector(0, tail_height * -1, 0), ROT0, VEC0)


objs = (obj1, obj2, obj3, obj4)
objs = (obj1, obj2, obj3, obj4)


obj = mfuse_obj("Forma esempio", objs)
obj = mfuse_obj("airplane", objs)
obj.Placement = FreeCAD.Placement(Vector(0,0,0), FreeCAD.Rotation(0,0,0), Vector(0,0,0))
obj.Placement = Placement(VEC0, Rotation(0, 0, -90), Vector(0, 0, tail_position))
obj.Placement = FreeCAD.Placement(Vector(0,0,0), FreeCAD.Rotation(0,0,-90), Vector(0,0,pos_ali))


DOC.recompute()
DOC.recompute()
Line 252: Line 316:
return obj
return obj


# objects definition


airplane()
aeroplano()


setview()
setview()


}}
}}
<translate>


<!--T:32-->
Let's explain something in the code:


<!--T:33-->
Analizziamo il codice:
* We have used a method to define a sphere, using the most easy definition, using only the radius.

* We have introduced a second writing for the '''Union''' or '''Fusion''', using multiple objects, not more distant from the usual '''Part::Fuse''' it uses '''Part:Multifuse'''. We only use one property {{incode|Shapes}}. We have passed a '''tuple''' as arguments, but it accepts also a '''list'''.
* Abbiamo definito un metodo per creare una sfera, abbiamo usato la definizione più semplice, definendo solo il raggio.
* We have defined a complex object '''airplane''', but we have done it in a '''"parametric"''' way, defining some parameters and deriving other parameters, through some calculation, based on the main parameters.
* Abbiamo introdotto una seconda forma per l''''Unione''' quella multipla, niente di speciale, notate solo che alla proprietà {{incode|Shapes}} abbiamo passato una '''tupla'''
* We have used some Placement {{incode|Placement}} poperties around in the method and before returning the final geometries we have used a {{incode|Rotation}} property with the ''Yaw-Pitch-Roll'' writing. Note the last {{incode|Vector(0, 0, tail_position)}}, that define a '''center of rotation''' of the whole geometry.
* Abbiamo definito una forma complessa, in modo '''"parametrico"''', cioè definendo alcuni parametri e mettendo delle formule che calcolano in modo automatico molti dei valori da passare alla geometria finale.
* Abbiamo usato prima di ritornare l'oggetto un posizionamento usando la poprietà {{incode|Rotation}} e il vettore finale del gruppo che definisce il '''centro di rotazione''', secondo la scrittura ''Yaw-Pitch-Roll''



<!--T:46-->
{| class="wikitable"
{| class="wikitable"
|-
|-
| [[File:Aereo.png|thumb|left|l'aereo di esempio]] || [[File:Aereo2.png|thumb|center|aereo ruotato]]||
| [[File:Aereo.png|thumb|left|Airplane example]] || [[File:Aereo2.png|thumb|center|Airplane rotated]]||
[[File:Aereo-prop.png|thumb|center|Prop Placement]]
[[File:Aereo-prop.png|thumb|center|Placement property]]
|}
|}


<!--T:34-->
It can be easily noted that '''airplane''' geometry rotate around his "barycenter" or "center of gravity", that I've fixed at wing center, a place that is relatively "natural", but could be placed wherever you want.


<!--T:35-->
Potete facilmente notare che l'aereo ruota attorno al suo "baricentro" che ho fissato nel centro delle ali, in modo che la rotazione sia relativamente "naturale".
The first {{incode|Vector(0, 0, 0)}} is the Translation vector, not used here, but if you substitute {{incode|airplane()}} with these lines:


</translate>
Notiamo però che se usiamo l'interfaccia grafica e visualizziamo la proprietà {{incode|Placement}} abbiamo i dati che abbiamo inserito, questo significa che ogni modifica della proprietà modificherà il posizionamento della geometria, l'osservazione sarà importante nel proseguimento del discorso.
{{Code|code=
obj_f = airplane()


print(obj_F.Placement)
}}
<translate>

<!--T:36-->
You will see in the Report window this text:

</translate>
{{Code|code=
Placement [Pos=(0, -21, 21), Yaw-Pitch-Roll=(0, 0, -90)]
}}
<translate>

<!--T:37-->
What has happened?

<!--T:38-->
FreeCAD has translated the {{incode|Vector(0, 0, 0), FreeCAD.Rotation(0, 0, -90), Vector(0, 0, tail_position)}} in other words our {{incode|Placement}} definition that specifies three components, '''Translation''', '''Rotation''' and '''center of rotation''' in the "internal" values of only two components, '''Translation''' and '''Rotation'''.

<!--T:39-->
you can easily visualize the value of {{incode|tail_position}} using a print statement in the {{incode|airplane()}} method and see that it is:

</translate>
{{Code|code=
tail_position = 21.0
}}
<translate>

<!--T:40-->
in other words the '''rotation center''' of the geometry is at {{incode|Vector(0, 0, 21)}}, but this rotation center is not shown in the GUI, it could be entered as a {{incode|Placement}} value, it could not be easily retrieved.

<!--T:41-->
This is the meaning of the word "awkward" that I've used to define {{incode|Placement}} property.


<!--T:47-->
This is the complete code example with a decent script docstring following [https://www.sphinx-doc.org/en/master/usage/extensions/example_google.html#example-google Google docstrings convention]:

<!--T:48-->
{{Code|code=
"""Sample code.

<!--T:49-->
Filename:
airplane.py

<!--T:50-->
Author:
Dormeletti Carlo (onekk)

<!--T:51-->
Version:
1.0

<!--T:52-->
License:
Creative Commons Attribution 3.0

<!--T:53-->
Summary:
This code is a sample code written for FreeCAD Wiki page.
It create and airplane shaped solid made using standard "Part WB" built in shapes.

<!--T:54-->
"""

<!--T:55-->
import FreeCAD
from FreeCAD import Placement, Rotation, Vector

<!--T:56-->
DOC = FreeCAD.activeDocument()
DOC_NAME = "Wiki_Example"

<!--T:57-->
# Helpers methods

<!--T:58-->
def clear_doc():
"""Clear activeDocument deleting all the objects."""
for obj in DOC.Objects:
DOC.removeObject(obj.Name)

<!--T:59-->
def setview():
"""Rearrange View."""
FreeCAD.Gui.SendMsgToActiveView("ViewFit")
FreeCAD.Gui.activeDocument().activeView().viewAxometric()

<!--T:60-->
if DOC is None:
FreeCAD.newDocument(DOC_NAME)
FreeCAD.setActiveDocument(DOC_NAME)
DOC = FreeCAD.activeDocument()
else:
clear_doc()

<!--T:61-->
ROT0 = Rotation(0, 0, 0)
VEC0 = Vector(0, 0, 0)

<!--T:62-->
# Script methods

<!--T:63-->
def my_cyl(name, ang, rad, hei):
"""Create a Cylinder."""
obj = DOC.addObject("Part::Cylinder", name)
obj.Angle = ang
obj.Radius = rad
obj.Height = hei

<!--T:64-->
DOC.recompute()

<!--T:65-->
return obj

<!--T:66-->
def my_sphere(name, rad):
"""Create a Sphere."""
obj = DOC.addObject("Part::Sphere", name)
obj.Radius = rad

<!--T:67-->
DOC.recompute()

<!--T:68-->
return obj

<!--T:69-->
def my_box2(name, len, wid, hei, cent=False, off_z=0):
"""Create a box with an optional z offset."""
obj_b = DOC.addObject("Part::Box", name)
obj_b.Length = len
obj_b.Width = wid
obj_b.Height = hei

<!--T:70-->
if cent is True:
pos = Vector(len * -0.5, wid * -0.5, off_z)
else:
pos = Vector(0, 0, off_z)

<!--T:71-->
obj_b.Placement = Placement(pos, ROT0, VEC0)

<!--T:72-->
DOC.recompute()

<!--T:73-->
return obj_b

<!--T:74-->
def mfuse_obj(name, objs):
"""Fuse multiple objects."""
obj = DOC.addObject("Part::MultiFuse", name)
obj.Shapes = objs
obj.Refine = True
DOC.recompute()

<!--T:75-->
return obj

<!--T:76-->
def airplane():
"""Create an airplane shaped solid."""
fuselage_length = 30
fuselage_diameter = 5
wing_span = fuselage_length * 1.75
wing_width = 7.5
wing_thickness = 1.5
tail_height = fuselage_diameter * 3.0
tail_position = fuselage_length * 0.70
tail_offset = tail_position - (wing_width * 0.5)

<!--T:77-->
obj1 = my_cyl("main_body", 360, fuselage_diameter, fuselage_length)

<!--T:78-->
obj2 = my_box2("wings", wing_span, wing_thickness, wing_width, True, tail_offset)

<!--T:79-->
obj3 = my_sphere("nose", fuselage_diameter)
obj3.Placement = Placement(Vector(0, 0, fuselage_length), ROT0, VEC0)

<!--T:80-->
obj4 = my_box2("tail", wing_thickness, tail_height, wing_width, False, 0)
obj4.Placement = Placement(Vector(0, tail_height * -1, 0), ROT0, VEC0)

<!--T:81-->
objs = (obj1, obj2, obj3, obj4)

<!--T:82-->
obj = mfuse_obj("airplane", objs)
obj.Placement = Placement(VEC0, Rotation(0, 0, -90), Vector(0, 0, tail_position))

<!--T:83-->
DOC.recompute()

<!--T:84-->
return obj

<!--T:85-->
# objects definition

<!--T:86-->
airplane()

<!--T:87-->
setview()
}}


<!--T:43-->
{{Docnav
|[[Macros|Macros]]
|[[Introduction_to_Python|Introduction to Python]]
}}


</translate>
'''Alla prossima!'''
{{Powerdocnavi{{#translation:}}}}
[[Category:Developer Documentation{{#translation:}}]]
[[Category:Python Code{{#translation:}}]]

Latest revision as of 22:20, 6 November 2023

Tutorial
Topic
Scripting
Level
Base
Time to complete
Authors
onekk Carlo
FreeCAD version
0.19
Example files
See also
None

Introduction

With Scripting we mean create topological objects using FreeCAD's Python interpreter. FreeCAD could be used as a "very good" replacement of OpenSCAD, mainly because it has a real Python interpreter, that means that it has a real programming language on board, almost everything you could do with the GUI, is doable with a Python Script.

Sadly information about scripting in the documentation, and even in this wiki are scattered around and lacks of "writing" uniformity and most of them are explained in a too technical manner.

Getting started

The first obstacle in an easy way to scripting is that there is no direct way to access the FreeCAD internal Python editor through a menu item or a icon on the toolbar area, but knowing that FreeCAD opens a file with a .py extension in the internal Python editor, the most simple trick is create in your favorite text editor and then open it with the usual command File → Open.

To make the things in a polite way, the file has to be written with some order, FreeCAD Python editor have a good "Syntax Highlighting" that lacks in many simple editors like Windows Notepad or some basic Linux editors, so it is sufficient to write these few lines:

"""filename.py

   A short description of what the script does

"""

Save them with a meaningfull name with .py extension and load the resulting file in FreeCAD, with the said File → Open command.

A minimal example of what is necessary to have in a script is shown in this portion of code that you could be use as a template for almost any future script:

"""filename.py

   First FreeCAD Script

"""

import FreeCAD
from FreeCAD import Placement, Rotation, Vector

DOC = FreeCAD.activeDocument()
DOC_NAME = "Wiki_Example"

# Helpers methods

def clear_doc():
    """Clear activeDocument deleting all the objects."""
    for obj in DOC.Objects:
        DOC.removeObject(obj.Name)

def setview():
    """Rearrange View."""
    FreeCAD.Gui.SendMsgToActiveView("ViewFit")
    FreeCAD.Gui.activeDocument().activeView().viewAxometric()

if DOC is None:
    FreeCAD.newDocument(DOC_NAME)
    FreeCAD.setActiveDocument(DOC_NAME)
    DOC = FreeCAD.activeDocument()
else:
    clear_doc()

ROT0 = Rotation(0, 0, 0)
VEC0 = Vector(0, 0, 0)

Some tricks are incorporated in the above code:

  • import FreeCAD This line import FreeCAD in the FreeCAD Python interpreter, it may seem a redundant thing, but it isn't.
  • from FreeCAD import Placement, Rotation, Vector Placement Rotation and Vector are widely used in FreeCAD scripting, import them in this manner will save you to invoke them with FreeCAD.Vector or FreeCAD.Placement instead of Vector or Placement, this will save many keystrokes and make codelines much smaller.

Let's start with a small script that does a very small job, but display the power of this approach.

# Script methods

def my_box(name, len, wid, hei):
    """Create a box."""
    obj_b = DOC.addObject("Part::Box", name)
    obj_b.Length = len
    obj_b.Width = wid
    obj_b.Height = hei

    DOC.recompute()

    return obj_b

# objects definition

obj = my_box("test_cube", 5, 5, 5)

setview()

Write above lines of code after # Script methods and press the green arrow in the Macro toolbar

You will see some magic things, a new document is open named "Wiki_example" and you will see in the 3d view a Cube, like the one in the image below.

Test cube

Something more

Not that amazing? Yes, but we have to start somewhere, we can do the same thing with a Cylinder, add these lines of code after the my_box() method and before the line: # objects definition.

def my_cyl(name, ang, rad, hei):
    """Create a Cylinder."""
    obj = DOC.addObject("Part::Cylinder", name)
    obj.Angle = ang
    obj.Radius = rad
    obj.Height = hei

    DOC.recompute()

    return obj

Even here nothing too exciting. But please note some peculiarities:

  • The absence of the usual reference to the App., present in many Documentation code snippets, is deliberate, this code could be used even invoking FreeCAD as a module in an external Python interpreter, the thing is not easily doable with an AppImage, but with some care it could be done. Plus in the standard Python motto that "better explicit than implicit" App. is explaining in a very "poor" way where the things are from.
  • Note the use of the "constant" name assigned to the active Document in DOC = FreeCAD.activeDocument(); activeDocument is not a "constant" in a strict sense, but in a "semantical" way is our "active Document", that for our use is a proper "constant" so the Python convention to use the "ALL CAPS" name for "constants", not to mention that DOC is much shorten than FreeCAD.activeDocument().
  • Every method returns a geometry, this will be clear in the continuation of the page.
  • Geometry didn't have the Placement property, when using the simple geometries to make more complex geometry, managing Placement is a awkward thing.

Now what to do with this geometries?

Let's introduce boolean operations. As a starter example put these lines after my_cyl, this create a method for a Fusion also know as Union operation:

def fuse_obj(name, obj_0, obj_1):
    """Fuse two objects."""
    obj = DOC.addObject("Part::Fuse", name)
    obj.Base = obj_0
    obj.Tool = obj_1
    obj.Refine = True
    DOC.recompute()

    return obj

Nothing exceptional also here, note however the uniformity in method coding; This approach is more linear that those seen around other tutorial on scripting, this "linearity" help greatly in readability and also with cut-copy-paste operations.

Let's use the geometries, delete lines below the code section starting with # objects definition, and insert the following lines:

# objects definition

obj = my_box("test_cube", 5, 5, 5)

obj1 = my_cyl("test_cyl", 360, 2, 10)

fuse_obj("Fusion", obj, obj1)

setview()

Launch the script with the green arrow and we will see in the 3D view something like:

Cube and cylinder

Placement

Placement Concept is relatively complex, see Aeroplane Tutorial for a more deep explanation.

We usually are in need of placing geometries respect each other, when building complex object this is a recurring task, the most common way is to use the geometry Placement property.

FreeCAD offer a wide choice of ways to set this property, one is more tailored to another depending the knowledge and the background of the user, but the more plain writing is explained in the cited Tutorial, it use a peculiar definition of the Rotation portion of Placement, quite easy to learn.

FreeCAD.Placement(Vector(0, 0, 0), FreeCAD.Rotation(10, 20, 30), Vector(0, 0, 0))

But over other consideration, one thing is crucial, geometry reference point, in other words the point from which the object is modeled by FreeCAD, as described in this table, copied from Placement:

Object Reference Point
Part.Box left (minx), front (miny), bottom (minz) vertex
Part.Sphere center of the sphere
Part.Cylinder center of the bottom face
Part.Cone center of bottom face (or apex if bottom radius is 0)
Part.Torus center of the torus
Features derived from Sketches the Feature inherits the Position of the underlying Sketch. Sketches always start with Position = (0, 0, 0). This position corresponds to the origin in the sketch.

This information has to be kept in mind especially when we have to apply a rotation.

Some examples may help, delete all the line after my_cyl method and insert the portion of code below:

def my_sphere(name, rad):
    """Create a Sphere."""
    obj = DOC.addObject("Part::Sphere", name)
    obj.Radius = rad

    DOC.recompute()

    return obj

def my_box2(name, len, wid, hei, cent=False, off_z=0):
    """Create a box with an optional z offset."""
    obj_b = DOC.addObject("Part::Box", name)
    obj_b.Length = len
    obj_b.Width = wid
    obj_b.Height = hei

    if cent is True:
        pos = Vector(len * -0.5, wid * -0.5, off_z)
    else:
        pos = Vector(0, 0, off_z)

    obj_b.Placement = Placement(pos, ROT0, VEC0)

    DOC.recompute()

    return obj_b

def mfuse_obj(name, objs):
    """Fuse multiple objects."""
    obj = DOC.addObject("Part::MultiFuse", name)
    obj.Shapes = objs
    obj.Refine = True
    DOC.recompute()

    return obj

def airplane():
    """Create an airplane shaped solid."""
    fuselage_length = 30
    fuselage_diameter = 5
    wing_span = fuselage_length * 1.75
    wing_width = 7.5
    wing_thickness = 1.5
    tail_height = fuselage_diameter * 3.0
    tail_position = fuselage_length * 0.70
    tail_offset = tail_position - (wing_width * 0.5)

    obj1 = my_cyl("main_body", 360, fuselage_diameter, fuselage_length)

    obj2 = my_box2("wings", wing_span, wing_thickness, wing_width, True, tail_offset)

    obj3 = my_sphere("nose", fuselage_diameter)
    obj3.Placement = Placement(Vector(0, 0, fuselage_length), ROT0, VEC0)

    obj4 = my_box2("tail", wing_thickness, tail_height, wing_width, False, 0)
    obj4.Placement = Placement(Vector(0, tail_height * -1, 0), ROT0, VEC0)

    objs = (obj1, obj2, obj3, obj4)

    obj = mfuse_obj("airplane", objs)
    obj.Placement = Placement(VEC0, Rotation(0, 0, -90), Vector(0, 0, tail_position))

    DOC.recompute()

    return obj

# objects definition

airplane()

setview()

Let's explain something in the code:

  • We have used a method to define a sphere, using the most easy definition, using only the radius.
  • We have introduced a second writing for the Union or Fusion, using multiple objects, not more distant from the usual Part::Fuse it uses Part:Multifuse. We only use one property Shapes. We have passed a tuple as arguments, but it accepts also a list.
  • We have defined a complex object airplane, but we have done it in a "parametric" way, defining some parameters and deriving other parameters, through some calculation, based on the main parameters.
  • We have used some Placement Placement poperties around in the method and before returning the final geometries we have used a Rotation property with the Yaw-Pitch-Roll writing. Note the last Vector(0, 0, tail_position), that define a center of rotation of the whole geometry.
Airplane example
Airplane rotated
Placement property

It can be easily noted that airplane geometry rotate around his "barycenter" or "center of gravity", that I've fixed at wing center, a place that is relatively "natural", but could be placed wherever you want.

The first Vector(0, 0, 0) is the Translation vector, not used here, but if you substitute airplane() with these lines:

obj_f = airplane()

print(obj_F.Placement)

You will see in the Report window this text:

Placement [Pos=(0, -21, 21), Yaw-Pitch-Roll=(0, 0, -90)]

What has happened?

FreeCAD has translated the Vector(0, 0, 0), FreeCAD.Rotation(0, 0, -90), Vector(0, 0, tail_position) in other words our Placement definition that specifies three components, Translation, Rotation and center of rotation in the "internal" values of only two components, Translation and Rotation.

you can easily visualize the value of tail_position using a print statement in the airplane() method and see that it is:

tail_position = 21.0

in other words the rotation center of the geometry is at Vector(0, 0, 21), but this rotation center is not shown in the GUI, it could be entered as a Placement value, it could not be easily retrieved.

This is the meaning of the word "awkward" that I've used to define Placement property.


This is the complete code example with a decent script docstring following Google docstrings convention:

"""Sample code.

Filename:
   airplane.py

Author:
    Dormeletti Carlo (onekk)

Version:
    1.0

License:
    Creative Commons Attribution 3.0

Summary:
    This code is a sample code written for FreeCAD Wiki page.
    It create and airplane shaped solid made using standard "Part WB" built in shapes.

"""

import FreeCAD
from FreeCAD import Placement, Rotation, Vector

DOC = FreeCAD.activeDocument()
DOC_NAME = "Wiki_Example"

# Helpers methods

def clear_doc():
    """Clear activeDocument deleting all the objects."""
    for obj in DOC.Objects:
        DOC.removeObject(obj.Name)

def setview():
    """Rearrange View."""
    FreeCAD.Gui.SendMsgToActiveView("ViewFit")
    FreeCAD.Gui.activeDocument().activeView().viewAxometric()

if DOC is None:
    FreeCAD.newDocument(DOC_NAME)
    FreeCAD.setActiveDocument(DOC_NAME)
    DOC = FreeCAD.activeDocument()
else:
    clear_doc()

ROT0 = Rotation(0, 0, 0)
VEC0 = Vector(0, 0, 0)

# Script methods

def my_cyl(name, ang, rad, hei):
    """Create a Cylinder."""
    obj = DOC.addObject("Part::Cylinder", name)
    obj.Angle = ang
    obj.Radius = rad
    obj.Height = hei

    DOC.recompute()

    return obj

def my_sphere(name, rad):
    """Create a Sphere."""
    obj = DOC.addObject("Part::Sphere", name)
    obj.Radius = rad

    DOC.recompute()

    return obj

def my_box2(name, len, wid, hei, cent=False, off_z=0):
    """Create a box with an optional z offset."""
    obj_b = DOC.addObject("Part::Box", name)
    obj_b.Length = len
    obj_b.Width = wid
    obj_b.Height = hei

    if cent is True:
        pos = Vector(len * -0.5, wid * -0.5, off_z)
    else:
        pos = Vector(0, 0, off_z)

    obj_b.Placement = Placement(pos, ROT0, VEC0)

    DOC.recompute()

    return obj_b

def mfuse_obj(name, objs):
    """Fuse multiple objects."""
    obj = DOC.addObject("Part::MultiFuse", name)
    obj.Shapes = objs
    obj.Refine = True
    DOC.recompute()

    return obj

def airplane():
    """Create an airplane shaped solid."""
    fuselage_length = 30
    fuselage_diameter = 5
    wing_span = fuselage_length * 1.75
    wing_width = 7.5
    wing_thickness = 1.5
    tail_height = fuselage_diameter * 3.0
    tail_position = fuselage_length * 0.70
    tail_offset = tail_position - (wing_width * 0.5)

    obj1 = my_cyl("main_body", 360, fuselage_diameter, fuselage_length)

    obj2 = my_box2("wings", wing_span, wing_thickness, wing_width, True, tail_offset)

    obj3 = my_sphere("nose", fuselage_diameter)
    obj3.Placement = Placement(Vector(0, 0, fuselage_length), ROT0, VEC0)

    obj4 = my_box2("tail", wing_thickness, tail_height, wing_width, False, 0)
    obj4.Placement = Placement(Vector(0, tail_height * -1, 0), ROT0, VEC0)

    objs = (obj1, obj2, obj3, obj4)

    obj = mfuse_obj("airplane", objs)
    obj.Placement = Placement(VEC0, Rotation(0, 0, -90), Vector(0, 0, tail_position))

    DOC.recompute()

    return obj

# objects definition

airplane()

setview()